/** 									// -o-
 * helper.pde
 *
 *   int fauxdiff(int axis_)  	 					// -o-
 *
 *   float round(float val, float magnitude)
 *   float round100(float val)
 *
 *   String makeSpacer(int strlen_)
 *
 *   String timestamp()
 *   String timestamp_ms(int ms_)
 *
 *   String printToggle(String name, int val)
 *   String printToggle(String name, int val, String sep)
 *   String printToggleState(int val)  [ALIAS: pts]
 *
 * ----------------------------------------------------------------------
 * Copyright © 2011, David Reeder.  All rights reserved.
 * Please see the LICENSE file in this distribution for license details.
 * ----------------------------------------------------------------------
 */


// ------------------------------------------------ -o--
// XXX  is this useful?  use for Buttons as well as Sliders?
int fauxdiff(int axis_, Slider obj)  					// -o-
{
  if (mousePressed) {
    if ( (mouseX >= obj.wl) && (mouseX <= obj.wr) 
    	    && (mouseY >= obj.hh) && (mouseY <= obj.hl) )
    {
      if (axis_ == obj.lengthAxis) {
	return mouseX;
      } else {
	return mouseY;
      }
    }
  }  // endif -- mousePressed
  
  return -1;
}



// ------------------------------------------------ -o--
float round(float val, float magnitude)
{
  return ((int) (magnitude*val)) / magnitude;
}

float round100(float val)  { return round(val, 100); } 	// XXX optimize?



// ------------------------------------------------ -o--
// generate a string of spaces that complements the length of a
//   preexisting field (strlen_), or starts a new line.
// strlen_ == -1 automatically forces a new line.
//
String makeSpacer(int strlen_) 
{
  char[]  buf;
  int 	  len = strlen_;

  if ((-1 == strlen_) || (Trigger.dumpTrigSpacer <= strlen_))  { len = 0; } 
  buf = new char[Trigger.dumpTrigSpacer - len];
  Arrays.fill(buf, ' ');

  return new String(buf);
}



// ------------------------------------------------ -o--
String timestamp()
{
  String[] months = { "", "Jan", "Feb", "Mar", "Apr", "May", "Jun", 
			  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

  int  hr = hour(),
       mn = minute();

  String 	hr0 = "",
   		mn0 = "";

  if (10 > hr)  { hr0 = "0"; }
  if (10 > mn)  { mn0 = "0"; }

  return year() + months[month()] + day() +"-"+ hr0 + hr + mn0 + mn;
}

String timestamp_ms(int ms_)
{
  int ms = (0>ms_)? millis(): ms_;

  int sec 	= ms / 1000 % 60,
      mn 	= sec % 60,
      hr 	= mn / 60;

  return hr +":"+ mn +":"+ sec +"."+ ms%1000;
}



// ------------------------------------------------ -o--
String printToggle(String name, int val)  { 
  return printToggle(name, val, null); 
}

String printToggle(String name, int val, String sep)
{
  String separator = ": ";
  if ( (null != sep) && ("" != sep) )  { separator = sep; }

  String onoff = "ON";
  if (0 == val) { onoff = "off"; }
  return name + separator + onoff;
}

String pts(int val)  		  { return printToggleState(val); }
String printToggleState(int val)  { return printToggle("", val, "[") + "]"; }

