/** 									// -o-
 * overlay_TEMPLATE.pde
 *
 *   void setupOsc()
 *
 *   void defineTriggers()
 *   void setupTriggers()
 *   void displayTriggers()
 *   void dumpTriggers()
 *   void scanTriggers()
 *
 * To establish a trigger:
 *   1  declare 
 *   2  define in defineTriggers(); 
 *        add dynamic system values in setupTriggers() 
 *   3  list in displayTriggers() and dumpTriggers()
 *   4  list in scanTriggers(); add state logic here.
 *
 * ----------------------------------------------------------------------
 * Copyright © 2011, David Reeder.  All rights reserved.
 * Please see the LICENSE file in this distribution for license details.
 * ----------------------------------------------------------------------
 */


// -------------------------------------------- -o--
// setupOsc()
//
// establish port for receiving OSC messages; establish IP address
// and port for sending OSC messages.
//
// CALLED BY: setup()
//
void setupOsc()
{
  // receiving port
  //
  osc = new OscP5(this, 42002); 

  // target IP and port
  //
  osc_target = new NetAddress("127.0.0.1", 57120); 	// sc canonical
}



// -------------------------------------------- -o--
// declare and define triggers
//

FIX -- declarations........

int enable_FIX = 0,
    enable_FIX = 0;



// CALLED BY: setup()
//
void defineTriggers() 							// -o--
{
  // -o-
  // FIX 
  //

  // -o-
  // FIX
  //

}  // defineTriggers()




// -------------------------------------------- -o--
// setup, display and dump triggers
//

// CALLED BY: setup()
//
void setupTriggers() 
{
  // define list of colors
  //
  colorlist = new HashMap();

  colorlist.put( "blue", 	#0000ff ); 	// *
  colorlist.put( "greygreen", 	#004411 );
  colorlist.put( "green", 	#00ff00 ); 	// *
  colorlist.put( "turquoise", 	#00ffff ); 	// *
  colorlist.put( "forestgreen", #0f5f3a );
  colorlist.put( "brightlime", 	#0fff55 ); 	// *
  colorlist.put( "skyblue", 	#1080ff ); 	// *
  colorlist.put( "darkblue", 	#111133 );
  colorlist.put( "brown", 	#222200 );
  colorlist.put( "limegreen", 	#4e9a1e ); 	// *
  colorlist.put( "mutedred", 	#771111 );
  colorlist.put( "purple", 	#8400b4 ); 	// *
  colorlist.put( "red", 	#ff0000 ); 	// *

  //colorlist.put( "newcolor", 	#TBD );

}  // setupTriggers()



// XXX  list all triggers intended to appear in the display
//
// CALLED BY: draw()
//
void displayTriggers() 							// -o--
{
  if (1 == enable_FIX) {
    FIX.display();
    FIX.display();
  }

  FIX

}  // displayTriggers()



// XXX  list all triggers that should be tracked
//
void dumpTriggers() 							// -o--
{
  println( "\nTRIGGERS--");
  println( "  (runtime: " + timestamp_ms(-1) +")\n" );

  if (1 == enable_FIX) {
    println(FIX.toString("FIX") +"\n");
    println(FIX.toString("FIX") +"\n");
  }

  FIX

}  // dumpTriggers()




// -------------------------------------------- -o--
// scan triggers and handle algebra of triggers
//
// CALLED BY: draw()
//
boolean  onceonly_FIX = true,
         onceonly_FIX = true;

FIX -- state globals...


void scanTriggers()
{
  // XXX  list all triggers intended to be activated by pixel differences;
  // NB  isActive() calls isDelayed() which maintains delayMode state
  //
  if (1 == enable_FIX) {
    FIX.isActive();
    FIX.isActive();
  }

  FIX


  // inter-trigger logic
  //
  if (1 == enable_FIX) 
  {
    FIX
  }

  FIX

}  // scanTriggers()

